//
//	CS575 Technical Project
//	Begurgitate
//	Spring 1999
//	Shayne White
//	for Professor Bergendahl
//
//	MainWindow.h 
//	The main window class interface file
//	Derived from BWindow
//
//	Log:
//	Author		Date		Change
//	ssw			03/06/1999	initial rev.
//

#ifndef MAIN_WINDOW_H
#define MAIN_WINDOW_H

#include <Window.h>
#include <be/interface/StatusBar.h>
#include <StringView.h>
#include <AppKit.h>
#include <InterfaceKit.h>
#include "Sysinfo.h"

class MainWindow : public BWindow 
{
public:
	MainWindow(BRect frame); 
	virtual ~MainWindow();
	virtual	bool	QuitRequested();
	void MessageReceived (BMessage* message);
	void SetupMenus();
	void GetInfo();
	
private:
	BStringView	*aView;
	
	BStatusBar  *sb;	
	BStatusBar	*sb1;
	BStatusBar	*sb2;
	BStatusBar	*sb3;
	BStatusBar	*sb4;
	
	BRect		menuFrame;
	
	char rampct[8];
	char sempct[8];
	char portpct[8];
	char threadpct[8];
	char teampct[8];
	
	Sysinfo *my_sysinfo;
	
};

#endif //MAIN_WINDOW_H
