//
//	CS575 Technical Project
//	Begurgitate
//	Spring 1999
//	Shayne White
//	for Professor Bergendahl
//
//	Sysinfo.cpp 
//	The class implementation file for the Sysinfo class
//	This class gathers and displays information from the OS
//
//	Log:
//	Author		Date		Change
//	ssw			03/06/1999	initial rev.
//
#include <iostream.h>
#include <math.h>
#include <be/kernel/OS.h>
#include "Sysinfo.h"

int32 iterations;

// default constructor
Sysinfo::Sysinfo()
{
	//first, let's init variables
	iterations = 0;
	
}

//	destructor
Sysinfo::~Sysinfo()
{
	//nothing to do here
}	

// data display methods
void Sysinfo::ShowData() const
{
	ShowThreadUtilization();
	ShowPageUtilization();
	ShowPageFaults();
	ShowPortUtilization();
	ShowSemUtilization();
	ShowTeamUtilization();
	
}

// thread related
void Sysinfo::ShowThreadUtilization() const
{
	cout << "Thread utilization: ";
	cout << sysinfo_m.used_threads;
	cout << " out of ";
	cout << sysinfo_m.max_threads;
	cout << " threads. " << endl;

} 

void Sysinfo::ShowMaxThreads() const
{
	cout << "Maximum Threads: ";
	cout << sysinfo_m.max_threads << endl;
}

void Sysinfo::ShowUsedThreads() const
{
	cout << "Used Threads: ";
	cout << sysinfo_m.used_threads << endl;
}

int32 Sysinfo::MaxThreads() 
{
	return sysinfo_m.max_threads;
}

int32 Sysinfo::UsedThreads() 
{
	return sysinfo_m.used_threads;
}

//page related
void Sysinfo::ShowPageUtilization() const
{
	cout << "Page utilization: ";
	cout << sysinfo_m.used_pages;
	cout << " out of ";
	cout << sysinfo_m.max_pages;
	cout << " pages. " << endl;

} 

void Sysinfo::ShowMaxPages() const
{
	cout << "Maximum Pages: ";
	cout << sysinfo_m.max_pages << endl;
}

void Sysinfo::ShowUsedPages() const
{
	cout << "Used Pages: ";
	cout << sysinfo_m.used_pages << endl;
}

void Sysinfo::ShowPageFaults() const
{
	cout << "Page Faults: ";
	cout << sysinfo_m.page_faults << endl;
}

int32 Sysinfo::MaxPages() 
{
	return sysinfo_m.max_pages;
}

int32 Sysinfo::UsedPages() 
{
	return sysinfo_m.used_pages;
}

//team related
void Sysinfo::ShowTeamUtilization() const
{
	cout << "Team utilization: ";
	cout << sysinfo_m.used_teams;
	cout << " out of ";
	cout << sysinfo_m.max_teams;
	cout << " teams. " << endl;

} 

void Sysinfo::ShowMaxTeams() const
{
	cout << "Maximum Teams: ";
	cout << sysinfo_m.max_teams << endl;
}

void Sysinfo::ShowUsedTeams() const
{
	cout << "Used Teams: ";
	cout << sysinfo_m.used_teams << endl;
}

int32 Sysinfo::MaxTeams() 
{
	return sysinfo_m.max_teams;
}

int32 Sysinfo::UsedTeams() 
{
	return sysinfo_m.used_teams;
}


//port related
void Sysinfo::ShowPortUtilization() const
{
	cout << "Port utilization: ";
	cout << sysinfo_m.used_ports;
	cout << " out of ";
	cout << sysinfo_m.max_ports;
	cout << " ports. " << endl;

} 

void Sysinfo::ShowMaxPorts() const
{
	cout << "Maximum Ports: ";
	cout << sysinfo_m.max_ports << endl;
}

void Sysinfo::ShowUsedPorts() const
{
	cout << "Used Ports: ";
	cout << sysinfo_m.used_ports << endl;
}

int32 Sysinfo::MaxPorts() 
{
	return sysinfo_m.max_ports;
}

int32 Sysinfo::UsedPorts() 
{
	return sysinfo_m.used_ports;
}

// semaphore related
void Sysinfo::ShowSemUtilization() const
{
	cout << "Semaphore utilization: ";
	cout << sysinfo_m.used_sems;
	cout << " out of ";
	cout << sysinfo_m.max_sems;
	cout << " semaphores. " << endl;

} 

void Sysinfo::ShowMaxSems() const
{
	cout << "Maximum Semaphores: ";
	cout << sysinfo_m.max_sems << endl;
}

void Sysinfo::ShowUsedSems() const
{
	cout << "Used Semaphores: ";
	cout << sysinfo_m.used_sems << endl;
}

int32 Sysinfo::MaxSems() 
{
	return sysinfo_m.max_sems;
}

int32 Sysinfo::UsedSems() 
{
	return sysinfo_m.used_sems;
}

// data gathering
void Sysinfo::RefreshSysData()
{
	get_system_info(&sysinfo_m);
	iterations ++;
	
}