//
//	CS575 Technical Project
//	Begurgitate
//	Spring 1999
//	Shayne White
//	for Professor Bergendahl
//
//	Sysinfo.h
//	The class interface file for the Sysinfo class
//	This class gathers and displays information from the OS
//
//	Log:
//	Author		Date		Change
//	ssw			03/06/1999	initial rev.
//
#ifndef _INC_SYSINFO_H
#define _INC_SYSINFO_H

class Sysinfo
{
public:

	// constructor
	Sysinfo();
	
	// destructors
	~Sysinfo();
	
	////////////////////////////////////////////////////
	// display methods
	////////////////////////////////////////////////////
	//show all the data
	void ShowData() const;
	
	// thread related
	void ShowThreadUtilization() const;
	void ShowMaxThreads() const;
	void ShowUsedThreads() const;
	int32 MaxThreads();
	int32 UsedThreads();
	
	// team related
	void ShowTeamUtilization() const;
	void ShowMaxTeams() const;
	void ShowUsedTeams() const;
	int32 MaxTeams();
	int32 UsedTeams();
	
	// port related
	void ShowPortUtilization() const;
	void ShowMaxPorts() const;
	void ShowUsedPorts() const;
	int32 MaxPorts();
	int32 UsedPorts();
		
	// semaphore related
	void ShowSemUtilization() const;
	void ShowMaxSems() const;
	void ShowUsedSems() const;
	int32 MaxSems();
	int32 UsedSems();
	
	// page related
	void ShowPageUtilization() const;
	void ShowMaxPages() const;
	void ShowUsedPages() const;
	void ShowPageFaults() const;
	int32 MaxPages();
	int32 UsedPages();
	
	//ShowFreeMemory() const;
	//ShowNumCPUs() const;
	//ShowCPUSpeed() const;
	
	// data gathering methods
	void RefreshSysData();
	//RefreshFileData();
	
	
private:

	system_info sysinfo_m;

};

#endif